Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 713)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 715)
@@ -892,17 +952,17 @@
             //////////////////////
             case DMA_RSP_IDLE_ERR:  // error  response has highest priority
-            {    	
+            {
                 if     (r_dma_cmd_to_dma_rsp_req.read())      r_dma_rsp_fsm = DMA_RSP_PUT_ERR;
                 else if(p_vci_ini_ram.rspval.read())          r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
-                else if(r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI; 
+                else if(r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI;
                 break;
             }
             ///////////////////////
             case DMA_RSP_PUT_DMA:  // put one flit of the DMA response into FIFO
-            {    	
+            {
                 dma_rsp_fifo_put    = true;
                 dma_rsp_fifo_rerror = p_vci_ini_ram.rerror.read();
                 dma_rsp_fifo_rdata  = p_vci_ini_ram.rdata.read();
-                dma_rsp_fifo_rsrcid = p_vci_ini_ram.rsrcid.read();
+                dma_rsp_fifo_rsrcid = m_srcid_lid_mask[p_vci_ini_ram.rsrcid.read()];
                 dma_rsp_fifo_rtrdid = p_vci_ini_ram.rtrdid.read();
                 dma_rsp_fifo_rpktid = p_vci_ini_ram.rpktid.read();
@@ -913,7 +973,9 @@
 
 #if DEBUG_DMA_RSP
-if( m_debug_activated ) 
-std::cout << "  <IOB DMA_RSP_PUT_DMA> Push DMA response into DMA_RSP FIFO" 
-          << " : rsrcid = " << std::hex << p_vci_ini_ram.rsrcid.read()
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB DMA_RSP_PUT_DMA> Push DMA response into DMA_RSP FIFO"
+          << std::hex
+          << " : rsrcid = " << m_srcid_lid_mask[p_vci_ini_ram.rsrcid.read()]
           << " / rtrdid = " << p_vci_ini_ram.rtrdid.read()
           << " / rpktid = " << p_vci_ini_ram.rpktid.read()
@@ -923,12 +985,13 @@
 #endif
                 break;
-		    }
+            }
             ///////////////////////
             case DMA_RSP_PUT_WTI:  // put single flit WTI response into FIFO
-            {    	
+            {
                 dma_rsp_fifo_put    = true;
                 dma_rsp_fifo_rerror = r_miss_wti_rsp_to_dma_rsp_rerror.read();
                 dma_rsp_fifo_rdata  = 0;
-                dma_rsp_fifo_rsrcid = r_miss_wti_rsp_to_dma_rsp_rsrcid.read();
+                dma_rsp_fifo_rsrcid = 
+                    m_srcid_lid_mask[r_miss_wti_rsp_to_dma_rsp_rsrcid.read()];
                 dma_rsp_fifo_rtrdid = r_miss_wti_rsp_to_dma_rsp_rtrdid.read();
                 dma_rsp_fifo_rpktid = r_miss_wti_rsp_to_dma_rsp_rpktid.read();
@@ -937,12 +1000,14 @@
                 // acknowledge request
                 r_miss_wti_rsp_to_dma_rsp_req = false;
- 
+
                 // update priority
                 r_dma_rsp_fsm = DMA_RSP_IDLE_ERR;
 
 #if DEBUG_DMA_RSP
-if( m_debug_activated ) 
-std::cout << "  <IOB DMA_RSP_PUT_WTI> Push WTI response into DMA_RSP FIFO" 
-          << " : rsrcid = " << std::hex << r_miss_wti_rsp_to_dma_rsp_rsrcid.read()
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB DMA_RSP_PUT_WTI> Push WTI response into DMA_RSP FIFO"
+          << std::hex
+          << " : rsrcid = " << m_srcid_lid_mask[r_miss_wti_rsp_to_dma_rsp_rsrcid.read()]
           << " / rtrdid = " << r_miss_wti_rsp_to_dma_rsp_rtrdid.read()
           << " / rpktid = " << r_miss_wti_rsp_to_dma_rsp_rpktid.read()
@@ -966,11 +1031,12 @@
                 // acknowledge request
                 r_dma_cmd_to_dma_rsp_req = false;
- 
+
                 // update priority
                 r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
 
 #if DEBUG_DMA_RSP
-if( m_debug_activated ) 
-std::cout << "  <IOB DMA_RSP_PUT_DMA> Push IOMMU ERROR response into DMA_RSP FIFO" 
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB DMA_RSP_PUT_DMA> Push IOMMU ERROR response into DMA_RSP FIFO"
           << " : rsrcid = " << std::hex << r_dma_cmd_to_dma_rsp_rsrcid.read()
           << " / rtrdid = " << r_dma_cmd_to_dma_rsp_rtrdid.read()
@@ -982,5 +1048,5 @@
                 break;
             }
-		} // end switch DMA_RSP FSM
+        } // end switch DMA_RSP FSM
     }  // end if FIFO full
 
@@ -989,5 +1055,5 @@
     // The TLB FSM handles the TLB miss requests from DMA_CMD FSM,
     // and the PTE inval request (from CONFIG_CMD FSM).
-    // PTE inval request have highest priority. In case of TLB miss, 
+    // PTE inval request have highest priority. In case of TLB miss,
     // this fsm searchs the requested PTE on the prefetch buffer.
     // In case of buffer miss,  it request the MISS_WTI FSM to access the memory.
@@ -1003,5 +1069,5 @@
                      // PTE inval request are handled as unmaskable interrupts
     {
-        if ( r_config_cmd_to_tlb_req.read() ) // Request for a PTE invalidation 
+        if ( r_config_cmd_to_tlb_req.read() ) // Request for a PTE invalidation
         {
             r_config_cmd_to_tlb_req  = false;
@@ -1010,5 +1076,5 @@
         }
 
-        else if ( r_dma_cmd_to_tlb_req.read() )   // request for a TLB Miss 
+        else if ( r_dma_cmd_to_tlb_req.read() )   // request for a TLB Miss
         {
             // Checking prefetch buffer
@@ -1016,40 +1082,42 @@
             {
                 if( r_tlb_buf_valid &&         // Hit on prefetch buffer
-                    (r_tlb_buf_vaddr.read() == 
+                    (r_tlb_buf_vaddr.read() ==
                     (r_dma_cmd_to_tlb_vaddr.read()& ~PTE2_LINE_OFFSET & ~K_PAGE_OFFSET_MASK)))
                 {
-                    size_t   pte_offset = (r_dma_cmd_to_tlb_vaddr.read()& PTE2_LINE_OFFSET)>>12; 
+                    size_t   pte_offset = (r_dma_cmd_to_tlb_vaddr.read()& PTE2_LINE_OFFSET)>>12;
                     uint32_t pte_flags  = r_tlb_buf_data[2*pte_offset];
-                    uint32_t pte_ppn    = r_tlb_buf_data[2*pte_offset+1]; 
-                
+                    uint32_t pte_ppn    = r_tlb_buf_data[2*pte_offset+1];
+
                     // Bit valid checking
-                    if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
+                    if ( not ( pte_flags & PTE_V_MASK) )    // unmapped
                     {
-                        std::cout << "VCI_IO_BRIDGE ERROR : " << name() 
+                        std::cout << "VCI_IO_BRIDGE ERROR : " << name()
                                   << " Page Table entry unmapped" << std::endl;
-                       
+
                         r_tlb_miss_error = true;
                         r_dma_cmd_to_tlb_req    = false;
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_IDLE> PTE2 Unmapped" << std::hex 
+std::cout << name()
+          << "  <IOB TLB_IDLE> PTE2 Unmapped" << std::hex
           << " / paddr = " << r_tlb_paddr.read()
           << " / PTE_FLAGS = " << pte_flags
           << " / PTE_PPN = " << pte_ppn << std::endl;
 #endif
-                        break; 
+                        break;
                     }
 
                     // valid PTE2 : we must update the TLB
-                    r_tlb_pte_flags = pte_flags; 
+                    r_tlb_pte_flags = pte_flags;
                     r_tlb_pte_ppn   = pte_ppn;
                     r_tlb_fsm       = TLB_PTE2_SELECT;
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_IDLE> Hit on prefetch buffer: PTE2" << std::hex
-          << " / PTE_FLAGS = " << pte_flags 
+std::cout << name()
+          << "  <IOB TLB_IDLE> Hit on prefetch buffer: PTE2" << std::hex
+          << " / PTE_FLAGS = " << pte_flags
           << " / PTE_PPN = " << pte_ppn << std::endl;
 #endif
-                    break;    
+                    break;
                 }
             }
@@ -1057,25 +1125,26 @@
             {
                 if( r_tlb_buf_valid &&         // Hit on prefetch buffer
-                    (r_tlb_buf_vaddr.read() == 
-                    (r_dma_cmd_to_tlb_vaddr.read()& ~PTE1_LINE_OFFSET & ~M_PAGE_OFFSET_MASK ))) 
-                {
-                    size_t   pte_offset = (r_dma_cmd_to_tlb_vaddr.read()& PTE1_LINE_OFFSET)>>21; 
+                    (r_tlb_buf_vaddr.read() ==
+                    (r_dma_cmd_to_tlb_vaddr.read()& ~PTE1_LINE_OFFSET & ~M_PAGE_OFFSET_MASK )))
+                {
+                    size_t   pte_offset = (r_dma_cmd_to_tlb_vaddr.read()& PTE1_LINE_OFFSET)>>21;
                     uint32_t pte_flags  = r_tlb_buf_data[pte_offset];
-                            
+
                     // Bit valid checking
-                    if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
+                    if ( not ( pte_flags & PTE_V_MASK) )    // unmapped
                     {
-                        std::cout << "VCI_IO_BRIDGE ERROR : " << name() 
+                        std::cout << "VCI_IO_BRIDGE ERROR : " << name()
                                   << " Page Table entry unmapped" << std::endl;
-                       
+
                         r_tlb_miss_error = true;
                         r_dma_cmd_to_tlb_req    = false;
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_IDLE> PTE1 Unmapped" << std::hex 
+std::cout << name()
+          << "  <IOB TLB_IDLE> PTE1 Unmapped" << std::hex
           << " / paddr = " << r_tlb_paddr.read()
           << " / PTE = " << pte_flags << std::endl;
 #endif
-                        break; 
+                        break;
                     }
 
@@ -1085,5 +1154,6 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_PTE1_GET> Hit on prefetch buffer: PTE1" << std::hex 
+std::cout << name()
+          << "  <IOB TLB_PTE1_GET> Hit on prefetch buffer: PTE1" << std::hex
           << " / paddr = " << r_tlb_paddr.read()
           << std::hex << " / PTE1 = " << pte_flags << std::endl;
@@ -1092,11 +1162,12 @@
                 }
             }
-       
+
             // prefetch buffer miss
-            r_tlb_fsm = TLB_MISS; 
+            r_tlb_fsm = TLB_MISS;
 
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_IDLE> Miss on prefetch buffer"
+std::cout << name()
+          << "  <IOB TLB_IDLE> Miss on prefetch buffer"
           << std::hex << " / vaddr = " << r_dma_cmd_to_tlb_vaddr.read() << std::endl;
 #endif
@@ -1107,7 +1178,7 @@
     case TLB_MISS: // handling tlb miss
     {
-        uint32_t	ptba = 0; 
-        bool		bypass;
-        vci_addr_t	pte_paddr;
+        uint32_t    ptba = 0;
+        bool        bypass;
+        vci_addr_t  pte_paddr;
 
 #ifdef INSTRUMENTATION
@@ -1116,6 +1187,6 @@
         // evaluate bypass in order to skip first level page table access
         bypass = r_iotlb.get_bypass(r_dma_cmd_to_tlb_vaddr.read(), &ptba);
-        
-        // Request MISS_WTI_FSM a transaction on INT Network 
+
+        // Request MISS_WTI_FSM a transaction on INT Network
         if ( not bypass )     // Read PTE1/PTD1 in XRAM
         {
@@ -1123,10 +1194,11 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_MISS> Read PTE1/PTD1 in memory" << std::endl;
+std::cout << name()
+          << "  <IOB TLB_MISS> Read PTE1/PTD1 in memory" << std::endl;
 #endif
             pte_paddr = (vci_addr_t)((r_iommu_ptpr.read()) << (INDEX1_NBITS+2)) |
                         (vci_addr_t)((r_dma_cmd_to_tlb_vaddr.read() >> PAGE_M_NBITS) << 2);
             r_tlb_paddr = pte_paddr;
-            
+
             r_tlb_to_miss_wti_cmd_req = true;
             r_tlb_miss_type           = PTE1_MISS;
@@ -1138,12 +1210,13 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_MISS> Read PTE2 in memory" << std::endl;
+std::cout << name()
+          << "  <IOB TLB_MISS> Read PTE2 in memory" << std::endl;
 #endif
             //&PTE2 = PTBA + IX2 * 8
             pte_paddr = (vci_addr_t)ptba << PAGE_K_NBITS |
                         (vci_addr_t)(r_dma_cmd_to_tlb_vaddr.read()&PTD_ID2_MASK)>>(PAGE_K_NBITS-3);
-            
+
             r_tlb_paddr = pte_paddr;
-            
+
             r_tlb_to_miss_wti_cmd_req = true;
             r_tlb_miss_type           = PTE2_MISS;
@@ -1153,48 +1226,49 @@
         break;
     }
-    //////////////////  
-    case TLB_PTE1_GET:	// Try to read a PT1 entry in the miss buffer
-    {
-        
+    //////////////////
+    case TLB_PTE1_GET:  // Try to read a PT1 entry in the miss buffer
+    {
+
         uint32_t  entry;
-        
+
         vci_addr_t line_number  = (vci_addr_t)((r_tlb_paddr.read())&(CACHE_LINE_MASK));
         size_t word_position = (size_t)( ((r_tlb_paddr.read())&(~CACHE_LINE_MASK))>>2 );
 
-        // Hit test. Just to verify. 
+        // Hit test. Just to verify.
         // Hit must happen, since we've just finished its' miss transaction
-        bool hit = (r_tlb_buf_valid && (r_tlb_buf_tag.read()== line_number) ); 
-        assert(hit and "Error: No hit on prefetch buffer after Miss Transaction"); 
-        
+        bool hit = (r_tlb_buf_valid && (r_tlb_buf_tag.read()== line_number) );
+        assert(hit and "Error: No hit on prefetch buffer after Miss Transaction");
+
         entry = r_tlb_buf_data[word_position];
-            
+
         // Bit valid checking
-        if ( not ( entry & PTE_V_MASK) )	// unmapped
+        if ( not ( entry & PTE_V_MASK) )    // unmapped
         {
             //must not occur!
             std::cout << "IOMMU ERROR " << name() << "TLB_IDLE state" << std::endl
                       << "The Page Table entry ins't valid (unmapped)" << std::endl;
-                       
+
             r_tlb_miss_error       = true;
             r_dma_cmd_to_tlb_req   = false;
-            r_tlb_fsm              = TLB_IDLE;            
+            r_tlb_fsm              = TLB_IDLE;
 
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
 {
-    std::cout << "  <IOB DMA_PTE1_GET> First level entry Unmapped"
+    std::cout << name()
+              << "  <IOB DMA_PTE1_GET> First level entry Unmapped"
               << std::hex << " / paddr = " << r_tlb_paddr.read()
               << std::hex << " / PTE = " << entry << std::endl;
 }
 #endif
-                    break; 
+                    break;
         }
-    
-        if( entry & PTE_T_MASK ) 	//  PTD : me must access PT2
+
+        if( entry & PTE_T_MASK )    //  PTD : me must access PT2
         {
             // register bypass
             r_iotlb.set_bypass( r_dma_cmd_to_tlb_vaddr.read(),
-                                entry & ((1 << (vci_param_int::N-PAGE_K_NBITS)) - 1), 
-                                0); //nline, unused 
+                                entry & ((1 << (vci_param_int::N-PAGE_K_NBITS)) - 1),
+                                0); //nline, unused
 
             // &PTE2 = PTBA + IX2 * 8
@@ -1213,10 +1287,11 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_PTE1_GET> Success. Search PTE2" << std::hex 
+std::cout << name()
+          << "  <IOB TLB_PTE1_GET> Success. Search PTE2" << std::hex
           << " / PADDR = " << r_tlb_paddr.read()
           << " / PTD = " << entry << std::endl;
 #endif
         }
-        else			//  PTE1 :  we must update the IOTLB
+        else            //  PTE1 :  we must update the IOTLB
                         //  Should not occur if working only with small pages
         {
@@ -1226,5 +1301,6 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_PTE1_GET> Success. Big page"
+std::cout << name()
+          << "  <IOB TLB_PTE1_GET> Success. Big page"
           << std::hex << " / paddr = " << r_tlb_paddr.read()
           << std::hex << " / PTE1 = " << entry << std::endl;
@@ -1234,11 +1310,11 @@
     }
     /////////////////////
-    case TLB_PTE1_SELECT:	// select a slot for PTE1 
-    {
-        size_t 	way;
-        size_t 	set;
-        
+    case TLB_PTE1_SELECT:   // select a slot for PTE1
+    {
+        size_t  way;
+        size_t  set;
+
         r_iotlb.select(  r_dma_cmd_to_tlb_vaddr.read(),
-                        true,  // PTE1 
+                        true,  // PTE1
                         &way,
                         &set );
@@ -1249,5 +1325,6 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_PTE1_SELECT> Select a slot in TLB"
+std::cout << name()
+          << "  <IOB TLB_PTE1_SELECT> Select a slot in TLB"
           << " / way = " << std::dec << way
           << " / set = " << set << std::endl;
@@ -1263,14 +1340,14 @@
     {
         uint32_t  pte   = r_tlb_pte_flags.read();
-        
+
         r_tlb_paddr = (vci_addr_t)( ((r_tlb_pte_flags.read() & PPN1_MASK) << 21)
                         | (r_dma_cmd_to_tlb_vaddr.read()& M_PAGE_OFFSET_MASK) );
-        
+
         // update TLB
-        r_iotlb.write( true,		// 2M page
+        r_iotlb.write( true,        // 2M page
                       pte,
-                      0,		// argument unused for a PTE1
-                      r_dma_cmd_to_tlb_vaddr.read(),    
-                      r_tlb_way.read(), 
+                      0,        // argument unused for a PTE1
+                      r_dma_cmd_to_tlb_vaddr.read(),
+                      r_tlb_way.read(),
                       r_tlb_set.read(),
                       0 );      //we set nline = 0
@@ -1283,5 +1360,6 @@
 if ( m_debug_activated )
 {
-std::cout << "  <IOB TLB_PTE1_UPDT> write PTE1 in TLB"
+std::cout << name()
+          << "  <IOB TLB_PTE1_UPDT> write PTE1 in TLB"
           << " / set = " << std::dec << r_tlb_set.read()
           << " / way = " << r_tlb_way.read() << std::endl;
@@ -1290,50 +1368,52 @@
 #endif
         // next state
-        r_tlb_fsm = TLB_RETURN;	// exit sub-fsm
+        r_tlb_fsm = TLB_RETURN; // exit sub-fsm
         break;
     }
     //////////////////
-    case TLB_PTE2_GET:	// Try to read a PTE2 (64 bits) in the miss buffer
-    {    
-        uint32_t 	pte_flags;
-        uint32_t 	pte_ppn;
-        
+    case TLB_PTE2_GET:  // Try to read a PTE2 (64 bits) in the miss buffer
+    {
+        uint32_t    pte_flags;
+        uint32_t    pte_ppn;
+
         vci_addr_t line_number  = (vci_addr_t)((r_tlb_paddr.read())&(CACHE_LINE_MASK));
         size_t word_position = (size_t)( ((r_tlb_paddr.read())&(~CACHE_LINE_MASK))>>2 );
-        
-        
+
+
         // Hit test. Just to verify.
-        bool hit = (r_tlb_buf_valid && (r_tlb_buf_tag.read()== line_number) ); 
-        assert(hit and "Error: No hit on prefetch buffer after Miss Transaction"); 
+        bool hit = (r_tlb_buf_valid && (r_tlb_buf_tag.read()== line_number) );
+        assert(hit and "Error: No hit on prefetch buffer after Miss Transaction");
         pte_flags= r_tlb_buf_data[word_position];
         pte_ppn= r_tlb_buf_data[word_position+1]; //because PTE2 is 2 words long
         // Bit valid checking
-        if ( not ( pte_flags & PTE_V_MASK) )	// unmapped
+        if ( not ( pte_flags & PTE_V_MASK) )    // unmapped
         {
             //must not occur!
             std::cout << "IOMMU ERROR " << name() << "TLB_IDLE state" << std::endl
                       << "The Page Table entry ins't valid (unmapped)" << std::endl;
-                       
+
             r_tlb_miss_error       = true;
             r_dma_cmd_to_tlb_req         = false;
-            r_tlb_fsm             = TLB_IDLE;            
+            r_tlb_fsm             = TLB_IDLE;
 
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_PTE2_GET> PTE2 Unmapped" << std::hex 
+std::cout << name()
+          << "  <IOB TLB_PTE2_GET> PTE2 Unmapped" << std::hex
           << " / PADDR = " << r_tlb_paddr.read()
           << " / PTE = " << pte_flags << std::endl;
 #endif
-            break; 
+            break;
         }
-            
-        r_tlb_pte_flags       = pte_flags; 
+
+        r_tlb_pte_flags       = pte_flags;
         r_tlb_pte_ppn         = pte_ppn;
         r_tlb_fsm           = TLB_PTE2_SELECT;
-                
+
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_PTE2_GET> Mapped" << std::hex
-          << " / PTE_FLAGS = " << pte_flags 
+std::cout << name()
+          << "  <IOB TLB_PTE2_GET> Mapped" << std::hex
+          << " / PTE_FLAGS = " << pte_flags
           << " / PTE_PPN = " << pte_ppn << std::endl;
 #endif
@@ -1347,5 +1427,5 @@
 
         r_iotlb.select( r_dma_cmd_to_tlb_vaddr.read(),
-                        false,	// PTE2 
+                        false,  // PTE2
                         &way,
                         &set );
@@ -1356,5 +1436,6 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_PTE2_SELECT> Select a slot in IOTLB:"
+std::cout << name()
+          << "  <IOB TLB_PTE2_SELECT> Select a slot in IOTLB:"
           << " way = " << std::dec << way
           << " / set = " << set << std::endl;
@@ -1366,19 +1447,19 @@
     }
     ///////////////////
-    case TLB_PTE2_UPDT:      	// write a new PTE2 in tlb
+    case TLB_PTE2_UPDT:         // write a new PTE2 in tlb
                                 // not necessary to treat the L/R bit
     {
         uint32_t        pte_flags = r_tlb_pte_flags.read();
         uint32_t        pte_ppn   = r_tlb_pte_ppn.read();
-        
+
         r_tlb_paddr = (vci_addr_t)( ((r_tlb_pte_ppn.read() & PPN2_MASK) << 12)
                         | (r_dma_cmd_to_tlb_vaddr.read()& K_PAGE_OFFSET_MASK) );
-        
+
         // update TLB for a PTE2
-        r_iotlb.write( false,	// 4K page
+        r_iotlb.write( false,   // 4K page
                        pte_flags,
                        pte_ppn,
-                       r_dma_cmd_to_tlb_vaddr.read(),    
-                       r_tlb_way.read(), 
+                       r_dma_cmd_to_tlb_vaddr.read(),
+                       r_tlb_way.read(),
                        r_tlb_set.read(),
                        0 );     // nline = 0
@@ -1390,5 +1471,6 @@
 if ( m_debug_activated )
 {
-std::cout << "  <IOB TLB_PTE2_UPDT> write PTE2 in IOTLB"
+std::cout << name()
+          << "  <IOB TLB_PTE2_UPDT> write PTE2 in IOTLB"
           << " / set = " << std::dec << r_tlb_set.read()
           << " / way = " << r_tlb_way.read() << std::endl;
@@ -1397,5 +1479,5 @@
 #endif
         // next state
-        r_tlb_fsm = TLB_RETURN;	
+        r_tlb_fsm = TLB_RETURN;
         break;
     }
@@ -1404,5 +1486,5 @@
                      // PTE inval request are handled as unmaskable interrupts
     {
-        if ( r_config_cmd_to_tlb_req.read() ) // Request for a PTE invalidation 
+        if ( r_config_cmd_to_tlb_req.read() ) // Request for a PTE invalidation
         {
             r_config_cmd_to_tlb_req = false;
@@ -1414,8 +1496,8 @@
 m_cost_iotlbmiss_transaction++;
 #endif
-        if ( not r_tlb_to_miss_wti_cmd_req.read() )	//  Miss transaction completed
-        { 
-	        if ( r_miss_wti_rsp_error_miss.read() ) // bus error reported
-	        {
+        if ( not r_tlb_to_miss_wti_cmd_req.read() ) //  Miss transaction completed
+        {
+            if ( r_miss_wti_rsp_error_miss.read() ) // bus error reported
+            {
                 r_miss_wti_rsp_error_miss = false;
                 r_tlb_miss_error          = true;
@@ -1425,5 +1507,5 @@
             else if(r_tlb_miss_type == PTE1_MISS)
             {
-                r_tlb_fsm = TLB_PTE1_GET; 
+                r_tlb_fsm = TLB_PTE1_GET;
             }
             else
@@ -1440,5 +1522,6 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-std::cout << "  <IOB TLB_RETURN> IOTLB MISS completed" << std::endl;
+std::cout << name()
+          << "  <IOB TLB_RETURN> IOTLB MISS completed" << std::endl;
 #endif
         r_dma_cmd_to_tlb_req  = false;
@@ -1457,6 +1540,6 @@
             if(!r_tlb_buf_big_page)
             {
-               if( r_tlb_buf_vaddr.read() == 
-                   (r_config_cmd_to_tlb_vaddr.read()& ~PTE2_LINE_OFFSET) ) 
+               if( r_tlb_buf_vaddr.read() ==
+                   (r_config_cmd_to_tlb_vaddr.read()& ~PTE2_LINE_OFFSET) )
                 // The virtual address corresponds to one entry on the buffer line
                 {
@@ -1466,6 +1549,6 @@
             else    // First level entries on buffer. Unused if only small pages
             {
-               if( r_tlb_buf_vaddr.read() == 
-                   (r_config_cmd_to_tlb_vaddr.read()& ~PTE1_LINE_OFFSET) ) 
+               if( r_tlb_buf_vaddr.read() ==
+                   (r_config_cmd_to_tlb_vaddr.read()& ~PTE1_LINE_OFFSET) )
                 // The virtual address corresponds to one entry on the buffer line
                 {
@@ -1474,15 +1557,14 @@
             }
         }
-        
+
         // Invalidation on IOTLB
-        bool    ok;
-        ok = r_iotlb.inval(r_config_cmd_to_tlb_vaddr.read());
-         
-        if(r_waiting_transaction.read()) r_tlb_fsm =TLB_WAIT; 
+        r_iotlb.inval(r_config_cmd_to_tlb_vaddr.read());
+
+        if(r_waiting_transaction.read()) r_tlb_fsm =TLB_WAIT;
         else r_tlb_fsm = TLB_IDLE;
-        break; 
+        break;
     }
     } //end switch r_tlb_fsm
-    
+
     ////////////////////////////////////////////////////////////////////////////////
     // The CONFIG_CMD_FSM handles the VCI commands from the INT network.
@@ -1501,18 +1583,20 @@
     ///////////////////////////////////////////////////////////////////////////////
 
-    switch( r_config_cmd_fsm.read() ) 
+    switch( r_config_cmd_fsm.read() )
     {
     /////////////////////
     case CONFIG_CMD_IDLE:   // A VCI INT command is always consumed in this state
     {
-        if ( p_vci_tgt_int.cmdval.read() ) 
+        if ( p_vci_tgt_int.cmdval.read() )
         {
 
 #if DEBUG_CONFIG_CMD
 if( m_debug_activated )
-std::cout << "  <IOB CONFIG_CMD_IDLE> ### Config Command received" << std::endl 
+std::cout << name()
+          << "  <IOB CONFIG_CMD_IDLE> ### Config Command received" << std::endl
           << "  address = " << std::hex << p_vci_tgt_int.address.read()
           << " / srcid = " << p_vci_tgt_int.srcid.read()
           << " / trdid = " << p_vci_tgt_int.trdid.read()
+          << " / pktid = " << p_vci_tgt_int.pktid.read()
           << " / wdata = " << std::hex << p_vci_tgt_int.wdata.read()
           << " / be = " << p_vci_tgt_int.be.read()
@@ -1522,7 +1606,9 @@
             vci_addr_t paddr = p_vci_tgt_int.address.read();
             bool       read  = (p_vci_tgt_int.cmd.read() == vci_param_int::CMD_READ);
-            uint32_t   cell  = (uint32_t)((paddr & 0x1FF)>>2); 
+            uint32_t   cell  = (uint32_t)((paddr & 0x1FF)>>2);
             bool       eop   = p_vci_tgt_int.eop.read();
             bool       high  = (paddr & 0x4);
+            ext_data_t wdata = (ext_data_t)p_vci_tgt_int.wdata.read();
+            ext_be_t   be    = (ext_be_t)p_vci_tgt_int.be.read();
 
             // chek segments
@@ -1530,8 +1616,8 @@
             bool found   = false;
             bool special = false;
-            for ( seg = m_int_seglist.begin() ; 
+            for ( seg = m_int_seglist.begin() ;
                   seg != m_int_seglist.end() and not found ; seg++ )
             {
-                if ( seg->contains(paddr) )  
+                if ( seg->contains(paddr) )
                 {
                    found   = true;
@@ -1539,10 +1625,11 @@
                 }
             }
-           
+
             if ( found and special )  // IO_BRIDGE itself
             {
                 bool rerror = false;
-
-                assert( (p_vci_tgt_int.be.read() == 0xF) and
+                int_data_t rdata;
+
+                assert( (be == 0xF) and
                 "ERROR in vci_io_bridge : BE must be 0xF for a config access");
 
@@ -1552,66 +1639,50 @@
                 if ( not read && (cell == IOB_IOMMU_PTPR) )       // WRITE PTPR
                 {
-                    r_iommu_ptpr = (uint32_t)p_vci_tgt_int.wdata.read();
-                }
-                else if ( read && (cell == IOB_IOMMU_PTPR) )      // READ PTPR 
-                {
-                    r_config_cmd_to_config_rsp_rdata = r_iommu_ptpr.read();
+                    r_iommu_ptpr = (uint32_t)wdata;
+                }
+                else if ( read && (cell == IOB_IOMMU_PTPR) )      // READ PTPR
+                {
+                    rdata = r_iommu_ptpr.read();
                 }
                 else if( not read && (cell == IOB_WTI_ENABLE))  // WRITE WTI_ENABLE
                 {
-                    r_iommu_wti_enable = p_vci_tgt_int.wdata.read();
+                    r_iommu_wti_enable = wdata;
                 }
                 else if( read && (cell == IOB_WTI_ENABLE))       // READ WTI ENABLE
                 {
-                    r_config_cmd_to_config_rsp_rdata = r_iommu_wti_enable.read();
+                    rdata = r_iommu_wti_enable.read();
                 }
                 else if( read && (cell == IOB_IOMMU_BVAR))        // READ BVAR
                 {
-                    r_config_cmd_to_config_rsp_rdata = r_iommu_bvar.read();
+                    rdata = r_iommu_bvar.read();
                 }
                 else if( read && (cell == IOB_IOMMU_ETR))          // READ ETR
                 {
-                    r_config_cmd_to_config_rsp_rdata = r_iommu_etr.read();
+                    rdata = r_iommu_etr.read();
                 }
                 else if( read && (cell == IOB_IOMMU_BAD_ID))      // READ BAD_ID
                 {
-                    r_config_cmd_to_config_rsp_rdata = r_iommu_bad_id.read();
+                    rdata = r_iommu_bad_id.read();
                 }
                 else if( not read && (cell == IOB_INVAL_PTE))     // WRITE INVAL_PTE
                 {
                     r_config_cmd_to_tlb_req   = true;
-                    r_config_cmd_to_tlb_vaddr = (uint32_t)p_vci_tgt_int.wdata.read();
+                    r_config_cmd_to_tlb_vaddr = (uint32_t)wdata;
                 }
                 else if( not read && (cell == IOB_WTI_ADDR_LO)) // WRITE WTI_PADDR_LO
                 {
-                    r_iommu_wti_addr_lo = (vci_addr_t)p_vci_tgt_int.wdata.read();
+                    r_iommu_wti_addr_lo = (vci_addr_t)wdata;
                 }
                 else if( read && (cell == IOB_WTI_ADDR_LO))    // READ WTI_PADDR_LO
                 {
-                    r_config_cmd_to_config_rsp_rdata = r_iommu_wti_addr_lo.read();
+                    rdata = r_iommu_wti_addr_lo.read();
                 }
                 else if( not read && (cell == IOB_WTI_ADDR_HI)) // WRITE WTI_PADDR_HI
                 {
-                    r_iommu_wti_addr_hi = (vci_addr_t)p_vci_tgt_int.wdata.read();
+                    r_iommu_wti_addr_hi = (vci_addr_t)wdata;
                 }
                 else if( read && (cell == IOB_WTI_ADDR_HI))    // READ WTI_PADDR_HI
                 {
-                    r_config_cmd_to_config_rsp_rdata = r_iommu_wti_addr_hi.read();
-                }
-                else if( not read && (cell == IOB_XICU_BASE)) // WRITE XICU_BASE   
-                {
-                    r_xicu_base = (vci_addr_t)p_vci_tgt_int.wdata.read();
-                }
-                else if( read && (cell == IOB_XICU_BASE))    // READ XICU_BASE   
-                {
-                    r_config_cmd_to_config_rsp_rdata = r_xicu_base.read();
-                }
-                else if( not read && (cell == IOB_XICU_SIZE)) // WRITE XICU_SIZE   
-                {
-                    r_xicu_size = (vci_addr_t)p_vci_tgt_int.wdata.read();
-                }
-                else if( read && (cell == IOB_XICU_SIZE))    // READ XICU_SIZE   
-                {
-                    r_config_cmd_to_config_rsp_rdata = r_xicu_size.read();
+                    rdata = r_iommu_wti_addr_hi.read();
                 }
                 else   // Error: Wrong address, or invalid operation.
